!=========================================================================
! Copyright (C) GemTalk Systems, LLC. 2013.  All Rights Reserved.
!=========================================================================

! ------------------- Class definitions 

expectvalue %String
doit
(ReadStreamPortable subclass: 'PPStream'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #()
  inDictionary: Globals
  options: #()
) definition.
%

expectvalue %Boolean
! ------------------- Class comment for PPStream
doit
PPStream comment: 
'A positional stream implementation used for parsing. It overrides some methods for optimization reasons.'.
true
%
! ------------------- Class methods 

! Remove existing behavior from PPStream
removeallmethods PPStream
removeallclassmethods PPStream
! ------------------- Class methods for PPStream
! ------------------- Instance methods for PPStream
category: 'converting'
set compile_env: 0
method: PPStream
asPetitStream
	^ self
%
category: 'accessing'
set compile_env: 0
method: PPStream
peek
	"An improved version of peek, that is slightly faster than the built in version."

	^ self atEnd ifFalse: [ collection at: position + 1 ]
%
category: 'accessing'
set compile_env: 0
method: PPStream
position: anInteger
	"The receiver does not check for invalid arguments passed to this method, as it is solely used with valid indexes for backtracking."

	position := anInteger
%
category: 'printing'
set compile_env: 0
method: PPStream
printOn: aStream
	"use #canUnderstand: to somewhat hackily replace #isString. Possibly less bad than using #isKindOf:, though less obvious."

	(collection class canUnderstand: #codePointAt:)
		ifFalse: [^super printOn: aStream].
	aStream
		nextPutAll: (collection copyFrom: 1 to: position);
		nextPutAll: '-';
		nextPutAll: (collection copyFrom: position + 1 to: readLimit)
%
category: 'accessing'
set compile_env: 0
method: PPStream
uncheckedPeek
	"An unchecked version of peek that throws an error if we try to peek over the end of the stream, even faster than #peek."

	^ collection at: position + 1
%
expectValue %Boolean
doit
PPStream category: 'PPStream'.
true
%
! ------------------- Class initializers 
