!=========================================================================
! Copyright (C) GemTalk Systems 1986-2014.  All Rights Reserved.
!
! $Id: rcqsession.gs 32752 2014-02-28 22:11:10Z stever $
!
! Superclass Hierarchy:
!   RcQueueSessionComponent, Array, SequenceableCollection, Collection, Object.
!
!=========================================================================

expectvalue %String
run
  ^ Array _newKernelSubclass: 'RcQueueSessionComponent'
    instVarNames: #()
    classVars: #()
    classInstVars: #()
    poolDictionaries: { }
    inDictionary: Globals
    options: #()
    reservedOop: 853 .
%

removeallmethods RcQueueSessionComponent
removeallclassmethods RcQueueSessionComponent

category: 'For Documentation Installation only'
classmethod: RcQueueSessionComponent
installDocumentation

| doc txt |
doc := GsClassDocumentation _newForPrivateGsClass: self.

txt := (GsDocText new) details:
'An RcQueueSessionComponent is the unit within a reduced-conflict queue that
 holds all of the queue entries submitted by a given session.  A new RcQueue
 allows the same number of sessions as the GemStone system''s maximum number of
 sessions.  You can modify this number using the changeMaxSessionId: method.

Constraints:
	[elements]: RcQueueElement'.
doc documentClassWith: txt.

self comment: doc asString.
%

category: 'Constants'
classmethod: RcQueueSessionComponent
speciesOfElements

^RcQueueEntry
%

category: 'Copying'
method: RcQueueSessionComponent
postCopy

super postCopy.
1 to: self _basicSize do:[:n| self _at: n put: (self _at: n) copy ].
%

